Ticket #42502

Lua: player:give_bulbs() method

Open Date: 2021-06-10 02:54 Last Update: 2021-11-29 15:26

Reporter:
Owner:
Status:
Closed
Component:
MileStone:
Priority:
5 - Medium
Severity:
5 - Medium
Resolution:
Fixed
File:
1

Details

There are requests for things like giving some profit to a target player of "Enter Marketplace" action, or we may make tech stealth effectivity more even with a custom action, or something. Let's make a method that provides player with a given amount of bulbs; by default, commit them to the current research stock, in multiresearch mode let it be possible to specify a tech to commit to (that better needs also a function to test the current progress and cost of a tech for the player).

Ticket History (3/6 Histories)

2021-06-10 02:54 Updated by: ihnatus
  • New Ticket "Lua: player:give_bulbs() method" created
2021-10-12 04:33 Updated by: cazfi
  • Component Update from General to Scripting API
2021-10-15 07:57 Updated by: cazfi
Comment

I've been thinking about the corner-cases when reducing the amount of bulbs (we do that for tech upkeep, so it's possible). Maybe the wisest course of action is to have this method with the restriction that only positive values are allowed. That should make it safe to implement to 3.1 already. We can always add separate take_bulbs() method in later versions, if we want.

2021-11-11 14:50 Updated by: cazfi
  • Resolution Update from None to Accepted
Comment

Reply To cazfi

I've been thinking about the corner-cases when reducing the amount of bulbs (we do that for tech upkeep, so it's possible). Maybe the wisest course of action is to have this method with the restriction that only positive values are allowed. That should make it safe to implement to 3.1 already. We can always add separate take_bulbs() method in later versions, if we want.

Now I looked at it, and it might be a lot easier than I thought. Lower level code should do everything right even when we add very simple function to implement the lua API. So, the amount of bulbs is a signed value in the attached patch, after all.

2021-11-29 15:26 Updated by: cazfi
  • Status Update from Open to Closed
  • Owner Update from (None) to cazfi
  • Resolution Update from Accepted to Fixed

Edit

You are not logged in. I you are not logged in, your comment will be treated as an anonymous post. » Login